/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * Original Code is Martin Kutschker's code.
 *
 * The Initial Developer of the Original Code is Martin Kutschker.
 *
 * Copyright (c) 2001-2002 Martin Kutschker. All rights reserved.
 *
 * Contributor(s): 
 *   Martin Kutschker <Martin.T.Kutschker@blackbox.net> (Original Author)
 */

function initStore()
{
    // test for storage file in users dir and copy if necessary from default profile
    var dirHelper = new DirUtils();
    var storageFile = new File(dirHelper.getMozUserHomeDir());

    storageFile.append("mozcalc-storage.rdf");

    if (!storageFile.exists()) {
      var storageTemplate = new File(dirHelper.getProfileDefaultsDir());

      storageTemplate.append("mozcalc-storage.rdf");

      if (!storageTemplate.exists()) {
        //avoid annoying popups....
        //user may have purposefully disabled it
        //alert("default user profile data missing - memory and history not available");
        return;
      }

      if (!storageTemplate.copy(storageFile.path))  {
        //avoid annoying popups....
        //user may have purposefully disabled it
        //alert("could not copy default user profile data to '" +
        //      storageFile.path +
        //      "' - memory and history not available");
        return;
      }
    }

    gStorageRootRDF = new RDF("chrome://mozcalc/content/storageRoot.rdf",
                              "urn:storage",
                              "http://mozcalc.mozdev.org/rdf#");
    if (!gStorageRootRDF.dsource) {
       //avoid annoying popups....
       //user may have purposefully disabled it
       //alert("could not access RDF root file - memory and history not available");
       return;
    }

    gStorageRDF = new RDFFile(storageFile.path,
                              "urn:storage",
                              "http://mozcalc.mozdev.org/rdf#",
                              JSLIB_RDF_FLAG_DONT_CREATE);
    if (!gStorageRDF.dsource) {
       //avoid annoying popups....
       //user may have purposefully disabled it
       //alert("could not access RDF data file '" +
       //      storageFile.path +
       //      "' - memory and history not persistent");
       getInMemoryStorage();
    }

    attachStore();
}

function loadStore()
{
    // do nothing
}

function saveStore()
{
    if (gStorageRDF && gStorageRDF.loaded)
      gStorageRDF.flush();
}
