/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * Original Code is Martin Kutschker's code.
 *
 * The Initial Developer of the Original Code is Martin Kutschker.
 *
 * Copyright (c) 2001-2002 Martin Kutschker. All rights reserved.
 *
 * Contributor(s): 
 *   Martin Kutschker <Martin.T.Kutschker@blackbox.net> (Original Author)
 */

const WINDOWMEDIATOR_CID = "@mozilla.org/rdf/datasource;1?name=window-mediator";
const nsIWindowMediator  = Components.interfaces.nsIWindowMediator;

var windowManager = null;

try {
  var cWindowMediator = Components.classes[WINDOWMEDIATOR_CID].getService();
  windowManager = cWindowMediator.QueryInterface(nsIWindowMediator);
}
catch (e) {}

function mozcalcWindow() {
  openMozcalcWindow('main', 'mozcalc.xul');
}

function mozcalcAboutWindow() {
  //openMozcalcWindow('about', 'about.xul');
  window.openDialog('about.xul','_new','chrome,modal,centerscreen')
}

function openMozcalcWindow(name, filename) {
  var mozcalcWindow = null;

  if (windowManager) {
    mozcalcWindow = windowManager.getMostRecentWindow('mozcalc:'+name);
  }

  if (mozcalcWindow) {
    mozcalcWindow.focus();
  } else {
    if (windowManager) // no window manager means we have no privileges
      window.openDialog(filename,'mozcalc_'+name,'chrome');
    else
      window.open(filename,'mozcalc_'+name,'chrome');
  }
}
